/*jslint browser: true*/
/*global setInterval, clearInterval, swfobject, alert, console*/

//need in calling function
//var playerVersion, noFlashOnDevice = false, setupFlashTimer;
//success function is new - for swfPlayer April 2015
function detectFlashOnDevice(swfName, loadingDivId, percentDivId, successFunction, fullyLoadedFunction) {
	"use strict";
	var flashTimer, startingFlashTimer, flashTimerCount;

	function timeOutString() {
		return "<p>Loading Time exceeded.</p><p>Try refreshing or go to <a href='http://helpx.adobe.com/flash-player.html' target='_blank'>http://helpx.adobe.com/flash-player.html</a> to check your Flash Player installation.";
	}

	setupFlashTimer = function (swfName, loadingDivId, percentDivId) {
		flashTimerCount = 0;
		flashTimer = setInterval(function () {
			var loadingDiv = document.getElementById(loadingDivId)
			, percentDiv = document.getElementById(percentDivId)
			, currentPercent;
			flashTimerCount += 1;
			if (loadingDiv && (noFlashOnDevice || playerVersion.major < 8)) {
				document.body.removeChild(loadingDiv);
				clearInterval(flashTimer);
			} else {
				//IE forces us to use this odd typeof existence check - JSLint no for to likes
				var swfContainer;
				var foundContainer = false;
				//try the swfName given
				var swfNameArray = document.getElementsByName(swfName);
				for (var sn = 0; sn < swfNameArray.length; sn++){
					if (typeof swfNameArray.item(sn).PercentLoaded !== 'undefined'){
						swfContainer = swfNameArray.item(sn);
						foundContainer = true;
						break;
					}
				}
				if (!foundContainer){
					//try the inner one with name suffixed by NonIE
					swfNameArray = document.getElementsByName(swfName+'NonIE');
					for (var sn = 0; sn < swfNameArray.length; sn++){
						if (typeof swfNameArray.item(sn).PercentLoaded !== 'undefined'){
							swfContainer = swfNameArray.item(sn);
							foundContainer = true;
							break;
						}
					}
				}

				if (percentDiv && swfContainer) {
					currentPercent = swfContainer.PercentLoaded();
					percentDiv.innerHTML = "<p>Currently loaded " + currentPercent + "%</p>";
					if (currentPercent === 100) {
						document.body.removeChild(loadingDiv);
						clearInterval(flashTimer);
						if (fullyLoadedFunction){
							fullyLoadedFunction();
						}
					}
				} else if (flashTimerCount > 200) {					clearInterval(flashTimer);
					percentDiv.innerHTML = timeOutString();  //from noFlashDetect.js
				} else {
					percentDiv.innerHTML = "<p>Waiting... " + Math.round(flashTimerCount/2) + "</p>";
				}
			}
		}, 100);
	}

	function oldDetectFlashOnDevice(swfName, loadingDivId, percentDivId) {
		var output
		, noFlashDevice = ['iPad', 'iPhone', 'iPod']
		, i
		, messageText
		, messageParagraph
		, percentDiv
		, loadingDiv;
		clearInterval(flashTimer);
		if(!playerVersion){
			playerVersion = swfobject.getFlashPlayerVersion();
		}
		output = "You have Flash player " +   playerVersion.major + "." + playerVersion.minor + "." + playerVersion.release + " installed.";
		for (i = 0; i < noFlashDevice.length; i += 1) {
			if (navigator.platform === noFlashDevice[i]) {
				noFlashOnDevice = true;
				break;
			}
		}
		if (noFlashOnDevice) {
			//iOS
			messageText = "<h2>Flash Player not Supported</h2><p>You appear to be accessing this page from a device that does not support the Adobe Flash Player.</p>";
			if (puffinAvailable) {
				messageText += "<br /><p>You can view this page by downloading the free Puffin Academy app and searching for mathies.&nbsp;&nbsp;&nbsp;&nbsp;<a href='http://mathclips.wikispaces.com/Using+MathCLIPS+on+Mobile' target='_blank'>More...</a></p>";
				if (currentURL){
					messageText = testSWFURL("iOS") + messageText;
				}
			} else {
				messageText += "<br /><p>You may be able to view this page in an app that works around this limitation.</p>";
			}
		} else {
			if (playerVersion.major === 0) {
				messageText = "<h2>You don't appear to have Adobe Flash Player installed</h2>";
				if (puffinAvailable){
					messageText += "<br /><p>You can view this page by downloading the free Puffin Academy app and searching for mathies.&nbsp;&nbsp;&nbsp;&nbsp;<a href='http://mathclips.wikispaces.com/Using+MathCLIPS+on+Mobile' target='_blank'>More...</a></p>";
					if (currentURL){
						messageText = testSWFURL("android") + messageText;
					}
					/*messageText += "<br /><p>Although no longer supported by Adobe, some Android devices can enable the Flash Player successfully (see <a href='http://helpx.adobe.com/flash-player/kb/installing-flash-player-android-devices.html' target='_blank'>details</a>).  Please note that these directions are for experienced users and have security and performance risks associated with them.</p>";*/
				} else {
					messageText += "<p>Connect to the Internet, refresh and click the image below to visit <a href='http://get.adobe.com/flashplayer/' target='_blank'>http://get.adobe.com/flashplayer/</a>.  Some mobile devices do not support the Adobe Flash Player.</p>";
					messageText += "<a href='http://get.adobe.com/flashplayer/' target='_blank'><img src='http://www.adobe.com/misc/images/160x41_get_flashplayer.gif'/></a>";
				}
			}
			if (playerVersion.major < 8 && playerVersion.major > 0) {
				alert(output + "\nMathCLIPS requires version 8 or above.\n\nPlease update your browser by visiting\nhttp://get.adobe.com/flashplayer/.");
			}
			if (playerVersion.major > 7 && swfName) {
				setupFlashTimer(swfName, loadingDivId, percentDivId);
			}
		}
		if (messageText) {
			/*loadingDiv = document.getElementById(loadingDivId);
			loadingDiv.innerHTML = messageText;
			var swfID = document.getElementsByName(swfName)[0];
			swfID.parentNode.removeChild(swfID);*/
			document.body.innerHTML = messageText;
		} else if (successFunction){
			successFunction();
		}
	}

	function testSWFURL(osString){
		var appStoreID, playStoreID, toolName, gameName, anchorID, divStart, divEnd;
		if (currentURL){
			if (currentURL.indexOf('ColourTiles1') > -1){
				toolName = 'Colour Tiles';
				appStoreID = 'id1170196025';
				playStoreID = 'air.ca.mathies.colourTiles';
				anchorID = 'Cc5';
			} else if (currentURL.indexOf('FractionStrips1') > -1){
				toolName = 'Fraction Strips';
				appStoreID = 'id1233729371';
				playStoreID = 'air.ca.mathies.fractionStrips';
				anchorID = 'Ff0';
			} else if (currentURL.indexOf('MoneyRepresentation1') > -1){
				toolName = 'Money Representation Tool';
				appStoreID = 'id969207051';
				playStoreID = 'air.ca.mathies.money'; //Had to change for v2
				anchorID = 'Mm0';
			} else if (currentURL.indexOf('notepad1') > -1 || currentURL.indexOf('Notepad1')){
				toolName = 'Notepad Tool';
				appStoreID = 'id969193096';
				playStoreID = 'air.ca.mathies.notepad';
				anchorID = 'Nn0';
			} else if (currentURL.indexOf('Rekenrek1') > -1){
				toolName = 'Rekenrek Tool';
				appStoreID = 'id868343670';
				playStoreID = 'air.ca.mathclips.clips.rekenrek';
				anchorID = 'Rr0';
			} else if (currentURL.indexOf('RelationalRods1') > -1){
				toolName = 'Relational Rods+ Tool';
				appStoreID = 'id960682555';
				playStoreID = 'air.ca.mathclips.clips.relationalRods';
				anchorID = 'Rr6';
			} else if (currentURL.indexOf('Set1') > -1){
				toolName = 'Set Tool';
				appStoreID = 'id1170210844';
				playStoreID = 'air.ca.mathies.set';
				anchorID = 'Ss1';
			} else if (currentURL.indexOf('CatchBallOperations1') > -1){
				gameName = 'Catch a Bouncing Ball - Operations';
				appStoreID = 'id1183505802';
				playStoreID = 'air.ca.mathclips.catchball';
				anchorID = 'Cc5';
			}
			if (gameName){
				divStart = '<div style="background-color: #e8fdd9"><br /><h1 style="color:#0067bc;font-size: 3em;">';
				divEnd = '<br>You can install or open the '+gameName+' app from there.</p></div><p>For more options and more games visit <a href="http://oame.on.ca/mathies/games.php#'+anchorID+'" target="_blank">mathies.ca</a></p><br /><br /></div>'
				if (osString == 'iOS' && appStoreID){
					return divStart+gameName+'</h1><p><a class="button" href="itms-apps://itunes.apple.com/ca/app/'+appStoreID+'" title="View in App Store" target="_blank"><img src="http://oame.on.ca/mathies/images/iTunesAppStore.png" width="318px" height="98px"/></a></p><p><div style="font-size: 1.5em;">Click the button above to launch the App Store.'+divEnd;
				} else if (playStoreID){
					return divStart+gameName+'</h1><p><a class="button" href="http://play.google.com/store/apps/details?id='+playStoreID+'" title="View in Play Store" target="_blank"><img src="http://oame.on.ca/mathies/images/GooglePlayStore.png" width="318px" height="98px"/></a></p><p><div style="font-size: 1.5em;">Click the button above to launch the Google Play Store.'+divEnd;
				}
			} else if (toolName){
				divStart = '<div style="background-color: #e8fdd9"><br /><h1 style="color:#0067bc;font-size: 3em;">';
				divEnd = '<br>You can install or open the '+toolName+' app from there.</p></div><p>For more options and more learning tools visit <a href="http://oame.on.ca/mathies/learningTools.php#'+anchorID+'" target="_blank">mathies.ca</a></p><br /><br /></div>'
				if (osString == 'iOS' && appStoreID){
					return divStart+toolName+'</h1><p><a class="button" href="itms-apps://itunes.apple.com/ca/app/'+appStoreID+'" title="View in App Store" target="_blank"><img src="http://oame.on.ca/mathies/images/iTunesAppStore.png" width="318px" height="98px"/></a></p><p><div style="font-size: 1.5em;">Click the button above to launch the App Store.'+divEnd;
				} else if (playStoreID){
					return divStart+toolName+'</h1><p><a class="button" href="http://play.google.com/store/apps/details?id='+playStoreID+'" title="View in Play Store" target="_blank"><img src="http://oame.on.ca/mathies/images/GooglePlayStore.png" width="318px" height="98px"/></a></p><p><div style="font-size: 1.5em;">Click the button above to launch the Google Play Store.'+divEnd;
				}
			} else {
				//they have asked for some other game or tool on mobile
				return '<div style="background-color: #e8fdd9"><br /><h1 style="color:#0067bc;font-size: 3em;"></h1><p><a href="http://mathies.ca/apps.php" title="mathies apps">Mobile Apps</a></p><p>Click the link above to see a list of all mobile-friendly mathies apps.</p><br /><br /></div>';
			}
		}
		return "";
	}

	//started to need time to get swfObject to report getFlashPlayerVersion
	flashTimerCount = 0;
	startingFlashTimer = setInterval(function () {
		if (flashTimerCount > 50) {
			clearInterval(startingFlashTimer);
			document.getElementById(percentDivId).innerHTML = timeOutString();  //from noFlashDetect.js
		} else if (swfobject === undefined) {
			flashTimerCount += 1;
		} else {
			clearInterval(startingFlashTimer);
			oldDetectFlashOnDevice(swfName, loadingDivId, percentDivId);
		}
	}, 100);
}